<?php

namespace App\Controllers\Admin\Customer;

use App\Entities\Customer\AccountEntity;
use App\Entities\Customer\ClientEntity;
use App\Entities\Customer\CouponEntity;
use App\Helpers\Customer\ClientHelper;

use App\Services\Customer\ClientService;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use CodeIgniter\Validation\Validation;
use Psr\Log\LoggerInterface;

class ClientController extends CustomerController
{
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->title = lang("{$this->getService()->getClassName()}.title");
        $this->class_path .= $this->getService()->getClassName();
        $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
        // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;

    }
    public function getService(): ClientService
    {
        if (!$this->_service) {
            $this->_service = new ClientService($this->request);
        }
        return $this->_service;
    }
    public function getHelper(): ClientHelper
    {
        if (!$this->_helper) {
            $this->_helper = new ClientHelper($this->request);
        }
        return $this->_helper;
    }
    //Index,FieldForm관련
    protected function setValidation(Validation $validation, string $action, string $field, ?string $rule = null): Validation
    {
        switch ($field) {
            case 'role':
                //아래 Rule Array는 필드명.* checkbox를 사용
                $validation->setRule("{$field}.*", $field, $rule);
                break;
            default:
                $validation = parent::setValidation($validation, $action, $field, $rule);
                break;
        }
        return $validation;
    }
    //Index,FieldForm관련.

    //View관련
    protected function view_process($uid): mixed
    {
        $fields = [
            'fields' => ['name', 'email', 'phone', 'role', 'account_balance', 'coupon_balance', 'point_balance', 'status'],
        ];
        $this->init('view',  $fields);
        return parent::view_process($uid);
    }
    protected function index_process(): array
    {
        $fields = [
            'fields' => ['name', 'email', 'phone', 'role', 'account_balance', 'coupon_balance', 'point_balance', 'status'],
        ];
        $this->init('index',  $fields);
        return parent::index_process();
    }
}
